#pragma once

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>

#include "v3.h"
#include "ppc.h"

class FrameBuffer : public Fl_Gl_Window {
public:
	unsigned int *pix;
	int w, h;
	FrameBuffer(int u0, int v0, int _w, int _h);
	void draw();
	void KeyboardHandle();
	int handle(int guievent);
	void SetBGR(unsigned int bgr);
	void SetGuarded(int u, int v, unsigned int color);
	void Set(int u, int v, unsigned int color);

	void DrawRectangle(int u0, int v0, int u1, int v1, unsigned int color);
	int ClipToScreen(int &u0, int &v0, int &u1, int &v1);
	void DrawCircle(int u0, int v0, int R, unsigned int color);
	void DrawSegment(V3 p0, V3 c0, V3 p1, V3 c1);
	void Draw3DSegment(V3 p0, V3 c0, V3 p1, V3 c1, PPC *ppc);
	void Draw3DPoint(V3 p, V3 c, PPC *ppc, int psize);


	void LoadTiff(char* fname);
	void SaveAsTiff(char* fname);
};