#include "ppc.h"

#include "m33.h"

PPC::PPC(float hfov, int _w, int _h): a(1.0f, 0.0f, 0.0f), b(0.0f, -1.0f, 0.0f),
	C(0.0f, 0.0f, 0.0f), w(_w), h(_h) {

	float hfovr = hfov * 3.14159f / 180.0f;
	float f = -(float)w / (2.0f *tanf(hfovr / 2.0f));
	c = V3(-(float)w / 2.0f, (float)h / 2.0f, f);

}


int PPC::Project(V3 p, V3& pp) {

	M33 M; 
	M.SetColumn(0, a);
	M.SetColumn(1, b);
	M.SetColumn(2, c);
	V3 q = M.Inverted()*(p - C);
	if (q[2] < 0.0f)
		return 0;
	pp[2] = q[2];
	pp[0] = q[0] / q[2];
	pp[1] = q[1] / q[2];
	return 1;

}
